#!/bin/sh

apt-get update
apt-get --yes install binutils gcc-3.3

rm -r /tmp/toolchain-tests
mkdir /tmp/toolchain-tests
cd /tmp/toolchain-tests

echo 'main() {int a,b; return a*b;}' > test1.c
echo '#include <stdio.h>' > test2.c 
echo 'main() {printf("Hello World\n");}' >> test2.c

date


#for T in powerpc-linux s390-linux m68k-linux alpha-linux avr; do
#for T in arm-linux; do 

for T in arm-linux powerpc-linux ia64-linux hppa-linux mips-linux sparc-linux mipsel-linux s390-linux m68k-linux alpha-linux avr; do
  rm -r $T
  mkdir $T
  cd $T

  tpkg-install-libc $T
  tpkg-make $T

  cd binutils*
  debuild
  debi

  cd ../gcc*
  debuild
  debi

  cd ../gdb*
  debuild
  debi

  cd ../..
  $T-gcc -o test1.$T test1.c
  $T-gcc -o test2.$T test2.c

  if [ -f test1.$T ] ; then
    if [ -f test1.$T ] ; then
      rm -r $T
    fi
  fi

  date

done
